ZoneTrack = {}
ZoneTrackSaved = {
	TrackQuests = 1,
}

local VarsLoaded

local AltZoneNames = {
	stormwindstockade = "stockade",
}

local LastZoneText
local LastRealZoneText
local LastSubZoneText
local LastMinimapZoneText
local LastAltZoneText

local Frame = CreateFrame("Frame", nil, UIParent)

function ZoneTrack.Events(Self, Event, ...)
	if Event == "ADDON_LOADED" then
		VarsLoaded = true
	end
	if not VarsLoaded then return end
	
	local ZoneText = GetZoneText()
	local RealZoneText = GetRealZoneText()
	local SubZoneText = GetSubZoneText()
	local MinimapZoneText = GetMinimapZoneText()
	
	if not ( ZoneText or RealZoneText or SubZoneText or MinimapZoneText ) then return end
	
	if ZoneText then
		ZoneText = string.lower(ZoneText)
		if string.sub(ZoneText, 1, 4) == "the " then ZoneText = string.sub(ZoneText, 5) end
		ZoneText = string.gsub(ZoneText, " ", "")
		ZoneText = string.gsub(ZoneText, "-", "")
		ZoneText = string.gsub(ZoneText, "'", "")
		ZoneText = string.gsub(ZoneText, ":", "")
	end
	
	if RealZoneText then
		RealZoneText = string.lower(RealZoneText)
		if string.sub(RealZoneText, 1, 4) == "the " then RealZoneText = string.sub(RealZoneText, 5) end
		RealZoneText = string.gsub(RealZoneText, " ", "")
		RealZoneText = string.gsub(RealZoneText, "-", "")
		RealZoneText = string.gsub(RealZoneText, "'", "")
		RealZoneText = string.gsub(RealZoneText, ":", "")
	end
	
	if SubZoneText then
		SubZoneText = string.lower(SubZoneText)
		if string.sub(SubZoneText, 1, 4) == "the " then SubZoneText = string.sub(SubZoneText, 5) end
		SubZoneText = string.gsub(SubZoneText, " ", "")
		SubZoneText = string.gsub(SubZoneText, "-", "")
		SubZoneText = string.gsub(SubZoneText, "'", "")
		SubZoneText = string.gsub(SubZoneText, ":", "")
	end
	
	if MinimapZoneText then
		MinimapZoneText = string.lower(MinimapZoneText)
		if string.sub(MinimapZoneText, 1, 4) == "the " then MinimapZoneText = string.sub(MinimapZoneText, 5) end
		MinimapZoneText = string.gsub(MinimapZoneText, " ", "")
		MinimapZoneText = string.gsub(MinimapZoneText, "-", "")
		MinimapZoneText = string.gsub(MinimapZoneText, "'", "")
		MinimapZoneText = string.gsub(MinimapZoneText, ":", "")
	end
	
	local AltZoneText = AltZoneNames[ZoneText]
	
	if ZoneTrackSaved.TrackQuests == 1 then
		ExpandQuestHeader(0)		
		
		local Track
		
		for i = 1, GetNumQuestLogEntries() do
			local Title, _, _, IsHeader, _ = GetQuestLogTitle(i)
			
			if IsHeader then
				local HeaderTitle = string.lower(Title)
				if string.sub(HeaderTitle, 1, 4) == "the " then HeaderTitle = string.sub(HeaderTitle, 5) end
				HeaderTitle = string.gsub(HeaderTitle, " ", "")
				HeaderTitle = string.gsub(HeaderTitle, "-", "")
				HeaderTitle = string.gsub(HeaderTitle, "'", "")
				HeaderTitle = string.gsub(HeaderTitle, ":", "")

				if HeaderTitle == ZoneText or HeaderTitle == RealZoneText or HeaderTitle == SubZoneText or HeaderTitle == MinimapZoneText or HeaderTitle == AltZoneText then
					Track = "a"
				elseif HeaderTitle == LastZoneText or HeaderTitle == LastRealZoneText or HeaderTitle == LastSubZoneText or HeaderTitle == LastMinimapZoneText or HeaderTitle == LastAltZoneText then
					Track = "r"
				else
					Track = nil
				end
			else
				if Track == "a" then
					AddQuestWatch(i)
				elseif Track == "r" then
					RemoveQuestWatch(i)
				end
			end
		end
	end

	LastZoneText = ZoneText
	LastRealZoneText = RealZoneText
	LastSubZoneText = SubZoneText
	LastMinimapZoneText = MinimapZoneText
	LastAltZoneText = AltZoneText
end

Frame:RegisterEvent("ADDON_LOADED")
Frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
Frame:RegisterEvent("ZONE_CHANGED")
Frame:RegisterEvent("QUEST_ACCEPTED")
Frame:SetScript("OnEvent", ZoneTrack.Events)

function ZoneTrack.SlashCmds(Msg, EditBox)
	local lMsg
	if Msg then lMsg = string.lower(Msg) end
	
	if string.sub(lMsg,1,1) == "q" then
		if ZoneTrackSaved.TrackQuests == 1 then
			ZoneTrackSaved.TrackQuests = 0
			print("|cff0099ffWyeSoft Zone Track:|r Auto-tracking of quests disabled")
		else
			ZoneTrackSaved.TrackQuests = 1
			print("|cff0099ffWyeSoft Zone Track:|r Auto-tracking of quests enabled")
		end
	elseif string.sub(lMsg,1,1) == "i" then
		print("|cff0099ffWyeSoft Zone Track:|r")
		print("Zone text: ", GetZoneText())
		print("Real zone text: ", GetRealZoneText())
		print("Sub zone text: ", GetSubZoneText())
		print("Minimap zone text: ", GetMinimapZoneText())
	else
		print("|cff0099ffWyeSoft Zone Track:|r Available commands:")
		print("|cffffff00/ZONETRACK Q|r  toggles automatic tracking of quests when entering a zone.")
		print("|cffffff00/ZONETRACK I|r  displays information on the area you are currently in (intended for debugging purposes).")
		print("|cffffff00/ZONETRACK H|r  lists Zone Track's slash commands.")
	end
end

SLASH_ZONETRACK1 = "/zonetrack"
SLASH_ZONETRACK2 = "/wyesoftzonetrack"
SlashCmdList["ZONETRACK"] = ZoneTrack.SlashCmds
